# HERD-sRDMA
A secure implementation of the HERD key-value store.

## Dependencies:

  * sRDMA: a secure implementation of RDMA
  * openssl: a general-purpose cryptography library.
 
## Building
The whole project can be compiled using a single `Makefile`.
The makefile should be  manually configured by changing the absolute path to openssl.
sRDMA depends on openssl 1.1.1a (`https://www.openssl.org/source/old/1.1.1/openssl-1.1.1a.tar.gz`)

## Running the benchmark
Refer to the `./kvs-bench.sh --help`

## Client connection logic
The script launches applications in the following order:
 * smartnic1
 * smartnic2
 * Herd
 * Client

```
+------------------+                +------------------+
|                  |                |                  |
|      Client      |                |       Herd       |
|                  |                |                  |
|     at host1     |                |    at host2      |
|                  |                |                  |
|       ^^         |                |       ^^         |
|       ||         |                |       ||         |
|      PCIe        |                |      PCIe        |
|  +----||------+  |                |  +----||------+  |
|  |    vv    <----------QP RC---------->   vv      |  |
|  | smartnic1  |  |                |  | smartnic2  |  |
|  |            |  |                |  |            |  |
|  +------------+  |                |  +------------+  | 
|                  |                |                  |
+------------------+                +------------------+

```

## Contact
Konstantin Taranov (ktaranov@inf.ethz.ch)

